package org.dromara.work.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.RequiredArgsConstructor;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.work.domain.TpField;
import org.dromara.work.domain.bo.TpFieldBo;
import org.dromara.work.domain.vo.TpFieldVo;
import org.dromara.work.mapper.TpFieldMapper;
import org.dromara.work.service.ITpFieldService;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 字段管理Service业务层处理
 *
 * @author Maosw
 * @date 2024-08-12
 */
@RequiredArgsConstructor
@Service
public class TpFieldServiceImpl implements ITpFieldService {

    private final TpFieldMapper baseMapper;

    /**
     * 查询字段管理
     *
     * @param id 主键
     * @return 字段管理
     */
    @Override
    public TpFieldVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询字段管理列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 字段管理分页列表
     */
    @Override
    public TableDataInfo<TpFieldVo> queryPageList(TpFieldBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TpField> lqw = buildQueryWrapper(bo);
        Page<TpFieldVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的字段管理列表
     *
     * @param bo 查询条件
     * @return 字段管理列表
     */
    @Override
    public List<TpFieldVo> queryList(TpFieldBo bo) {
        LambdaQueryWrapper<TpField> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TpField> buildQueryWrapper(TpFieldBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TpField> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getType() != null, TpField::getType, bo.getType());
        lqw.like(StringUtils.isNotBlank(bo.getName()), TpField::getName, bo.getName());
        lqw.eq(bo.getAddTime() != null, TpField::getAddTime, bo.getAddTime());
        return lqw;
    }

    /**
     * 新增字段管理
     *
     * @param bo 字段管理
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TpFieldBo bo) {
        TpField add = MapstructUtils.convert(bo, TpField.class);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改字段管理
     *
     * @param bo 字段管理
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TpFieldBo bo) {
        TpField update = MapstructUtils.convert(bo, TpField.class);
        return baseMapper.updateById(update) > 0;
    }


    /**
     * 校验并批量删除字段管理信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        return baseMapper.deleteByIds(ids) > 0;
    }
}
